#include <iostream>

using namespace std;

//klasa kojom se opisuje jedan element liste
class ElementListe
{
public:
	//konstruktor klase ElementListe
	ElementListe( int v, ElementListe* l )
		: Vrednost(v),
		  Sledeci(l)
		{}

	//kopi-konstruktor
	ElementListe( const ElementListe& l )
		: Vrednost(l.Vrednost),
		  Sledeci(l.Sledeci ? new ElementListe(*l.Sledeci) : 0)
		{}

	int Vrednost;
	ElementListe* 	Sledeci;
};

//klasa kojom se opisuje lista
class Lista
{
public:
	//konstruktor klase Lista
	Lista()
		: _Pocetak(0)
		{}

	//kopi-konstriktor
	Lista( const Lista& l )
		: _Pocetak( l._Pocetak ? new ElementListe(*l._Pocetak) : 0)
		{}

	//destruktor klase Lista
	~Lista()
		{
		for( ElementListe* p=_Pocetak; p; ){
			ElementListe* t = p->Sledeci;
			delete p;
			p = t;
			}
		}

	//metod za dodavanje novog elementa na pocetak liste
	void DodajNaPocetak( int n )
		{
		ElementListe* novi = new ElementListe( n, _Pocetak );
		_Pocetak = novi;
		}

	//metod za dodavanje novog elementa na kraj liste
	void DodajNaKraj( int n )
		{
		ElementListe* novi = new ElementListe( n, 0 );
		if( _Pocetak ){
			ElementListe* p;
			for( p=_Pocetak; p->Sledeci; p=p->Sledeci )
				;
			p->Sledeci = novi;
			}
		else
			_Pocetak = novi;
		}

	//metod koji vraca vrednost i-tog elementa u listi (vazi samo ako postoji i+1-ti element)
	int Element( int i ) const
		{
		ElementListe* p = _Pocetak;
		for( int j=0; j<i; j++ )
			p = p->Sledeci;
		return p->Vrednost;
		}

	// metod koji racuna duzinu liste
	int Duzina() const
		{
		int n=0;
		for( ElementListe* p=_Pocetak; p; p=p->Sledeci )
			n++;
		return n;
		}

private:
	ElementListe* _Pocetak;
};

int main()
{
	Lista l;
	for( int i=9; i>=0; i--)
		l.DodajNaPocetak(i);

	int n = l.Duzina();

	cout << "Lista l:" << endl;

	for( int i=0; i<n; i++ )
		cout << l.Element(i) << ' ';
	cout << endl;

	//	pravimo kopiju liste
	Lista l1 = l;
	for( int i=10; i<20; i++ )
		l1.DodajNaKraj(i);
	n = l1.Duzina();

	cout << "Lista l1:" << endl;

	for( int i=0; i<n; i++ )
		cout << l1.Element(i) << ' ';
	cout << endl;

	n = l.Duzina();

	cout << "Lista l:" << endl;

	for( int i=0; i<n; i++ )
		cout << l.Element(i) << ' ';
	cout << endl;

	return 0;
}
