#include <iostream>

using namespace std;

//klasa kojom se opisuje jedan element liste
class ElementListe
{
public:
	//konstruktor klase ElementListe
	ElementListe( int v, ElementListe* l )
		: Vrednost(v),
		  Sledeci(l)
		{}

	int  Vrednost;
	ElementListe* 	Sledeci;
};

//klasa kojom se opisuje lista
class Lista
{
public:
	//konstruktor klase Lista
	Lista()
		: _Pocetak(0)
		{}

	//kopi-konstriktor
	Lista( const Lista& l )
		{ init(l); }

	//destruktor klase Lista
	~Lista()
		{ deinit(); }

        //operator dodeljivanja
	Lista& operator = ( const Lista& l )
		{
		if( this != &l ){
			deinit();
			init(l);
			}
		return *this;
		}

	//metod za dodavanje novog elementa na pocetak liste
	void DodajNaPocetak( int n )
		{
		ElementListe* novi = new ElementListe( n, _Pocetak );
		_Pocetak = novi;
		}

	//metod za dodavanje novog elementa na kraj liste
	void DodajNaKraj( int n )
		{
		ElementListe* novi = new ElementListe( n, 0 );
		if( _Pocetak ){
			ElementListe* p;
			for( p=_Pocetak; p->Sledeci; p=p->Sledeci )
				;
			p->Sledeci = novi;
			}
		else
			_Pocetak = novi;
		}
	//metod koji vraca vrednost i-tog elementa u listi (vazi samo ako postoji i+1-ti element)
	int Element( int i ) const
		{
		
		ElementListe* p = _Pocetak;
		for( int j=0; j<i; j++ )
			p = p->Sledeci;
		return p->Vrednost;
		}

	// metod koji racuna duzinu liste
	int Duzina() const
		{
		int n=0;
		for( ElementListe* p=_Pocetak; p; p=p->Sledeci )
			n++;
		return n;
		}

private:
	void init( const Lista& l )
		{
		if( l._Pocetak ){
			_Pocetak = new ElementListe( *l._Pocetak );
			ElementListe* p = _Pocetak;
			while(p->Sledeci){
				p->Sledeci = new ElementListe( *p->Sledeci );
				p = p->Sledeci;
				}
			}
		else
			_Pocetak = 0;
		}

	void deinit()
		{
		for( ElementListe* p=_Pocetak; p; ){
			ElementListe* t = p->Sledeci;
			delete p;
			p = t;
			}
		}

	ElementListe* _Pocetak;
};

int main()
{
	Lista l;
	for( int i=9; i>=0; i--)
			l.DodajNaPocetak(i);

	cout << "Lista l:" <<endl;
	int n = l.Duzina();
	for( int i=0; i<n; i++ )
		cout << l.Element(i) << ' ';
	cout << endl;

	Lista l1;
	for( int i=0; i<10; i++ )
		l1.DodajNaKraj(100+i);

	cout << "Lista l1:" <<endl;
	n = l1.Duzina();
	for( int i=0; i<n; i++ )
		cout << l1.Element(i) << ' ';
	cout << endl;

	cout << "Lista l1 posle l1=l:" <<endl;
	l1 = l;
	n = l1.Duzina();
	for( int i=0; i<n; i++ )
		cout << l1.Element(i) << ' ';
	cout << endl;

	cout << "Lista l1 posle dodavanja jos elemenata:" << endl;
	for( int i=0; i<10; i++ )
		l1.DodajNaKraj(i);
	n = l1.Duzina();
	for( int i=0; i<n; i++ )
		cout << l1.Element(i) << ' ';
	cout << endl;

	cout << "Lista l:" << endl;
	n = l.Duzina();
	for( int i=0; i<n; i++ )
		cout << l.Element(i) << ' ';
	cout << endl;

	return 0;
}
